]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Tripwirectrl gefixt.
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|voice|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 net-tools
302 lfsmake2 patch
303 lfsmake2 psmisc
304 lfsmake2 reiser4progs
305 lfsmake2 shadow
306 lfsmake2 sysklogd
307 lfsmake2 sysvinit
308 lfsmake2 tar
309 lfsmake2 texinfo
310 lfsmake2 udev
311 lfsmake2 util-linux
312 lfsmake2 vim
313 lfsmake2 grub
314 }
315
316 buildipfire() {
317 LOGFILE="$BASEDIR/log/_build.ipfire.log"
318 export LOGFILE
319 ipfiremake configroot
320 ipfiremake dhcp
321 ipfiremake dhcpcd
322 ipfiremake libusb
323 ipfiremake libpcap
324 ipfiremake linux-atm
325 ipfiremake ppp
326 ipfiremake rp-pppoe
327 ipfiremake unzip
328 ipfiremake linux SMP=1
329 ipfiremake ipp2p SMP=1
330 ipfiremake fcdsl SMP=1
331 ipfiremake fcdsl2 SMP=1
332 ipfiremake fcdslsl SMP=1
333 ipfiremake fcdslusb SMP=1
334 ipfiremake fcdslslusb SMP=1
335 ipfiremake fcpci SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 ipfiremake linux
340 ipfiremake ipp2p
341 ipfiremake fcdsl
342 ipfiremake fcdsl2
343 ipfiremake fcdslsl
344 ipfiremake fcdslusb
345 ipfiremake fcdslslusb
346 ipfiremake fcpci
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake expat
353 ipfiremake gdbm
354 ipfiremake gmp
355 ipfiremake pam
356 ipfiremake openssl
357 ipfiremake python
358 ipfiremake libnet
359 ipfiremake libjpeg
360 ipfiremake libpng
361 ipfiremake libtiff
362 ipfiremake lcms
363 ipfiremake libmng
364 ipfiremake freetype
365 ipfiremake libart
366 ipfiremake gd
367 ipfiremake popt
368 ipfiremake pcre
369 ipfiremake slang
370 ipfiremake newt
371 ipfiremake libcap
372 ipfiremake pciutils
373 ipfiremake libxml2
374 ipfiremake BerkeleyDB
375 ipfiremake mysql
376 ipfiremake cyrus-sasl
377 ipfiremake openldap
378 ipfiremake apache2
379 ipfiremake php
380 ipfiremake apache2 PASS=C
381 ipfiremake arping
382 ipfiremake beep
383 ipfiremake bind
384 ipfiremake capi4k-utils
385 ipfiremake cdrtools
386 ipfiremake dnsmasq
387 ipfiremake libaal
388 ipfiremake dosfstools
389 ipfiremake reiserfsprogs
390 ipfiremake squashfstools
391 ipfiremake sysfsutils
392 ipfiremake ntfs-3g
393 ipfiremake ethtool
394 ipfiremake ez-ipupdate
395 ipfiremake fcron
396 ipfiremake GD
397 ipfiremake GD-Graph
398 ipfiremake GD-TextUtil
399 ipfiremake gnupg
400 ipfiremake hdparm
401 ipfiremake ibod
402 ipfiremake initscripts
403 ipfiremake whatmask
404 ipfiremake iptables
405 ipfiremake libupnp
406 ipfiremake ipp2p IPT=1
407 ipfiremake moblock
408 ipfiremake linux-igd
409 ipfiremake ipac-ng
410 ipfiremake ipaddr
411 ipfiremake iptstate
412 ipfiremake iputils
413 ipfiremake l7-protocols
414 ipfiremake isapnptools
415 # ipfiremake isdn4k-utils # What about mISDN???
416 ipfiremake hwdata
417 ipfiremake kudzu
418 ipfiremake logrotate
419 ipfiremake logwatch
420 ipfiremake misc-progs
421 ipfiremake mtools
422 ipfiremake nano
423 ipfiremake nash
424 ipfiremake nasm
425 ipfiremake URI
426 ipfiremake HTML-Tagset
427 ipfiremake HTML-Parser
428 ipfiremake Compress-Zlib
429 ipfiremake Digest
430 ipfiremake Digest-SHA1
431 ipfiremake Digest-HMAC
432 ipfiremake libwww-perl
433 ipfiremake Net-DNS
434 ipfiremake Net-IPv4Addr
435 ipfiremake Net_SSLeay
436 ipfiremake IO-Stringy
437 ipfiremake Unix-Syslog
438 ipfiremake Mail-Tools
439 ipfiremake MIME-Tools
440 ipfiremake Net-Server
441 ipfiremake Convert-TNEF
442 ipfiremake Convert-UUlib
443 ipfiremake Archive-Tar
444 ipfiremake Archive-Zip
445 ipfiremake Text-Tabs+Wrap
446 ipfiremake Locale-Country
447 ipfiremake XML-Parser
448 ipfiremake glib
449 ipfiremake dbus
450 ipfiremake hal
451 ipfiremake hwinfo
452 ipfiremake GeoIP
453 ipfiremake fwhits
454 ipfiremake noip_updater
455 ipfiremake ntp
456 ipfiremake oinkmaster
457 ipfiremake openssh
458 ipfiremake openswan
459 ipfiremake pptpclient
460 ipfiremake rrdtool
461 ipfiremake setserial
462 ipfiremake setup
463 ipfiremake snort
464 ipfiremake squid
465 ipfiremake squid-graph
466 ipfiremake squidguard
467 ipfiremake calamaris
468 ipfiremake tcpdump
469 ipfiremake traceroute
470 ipfiremake vlan
471 ipfiremake wireless
472 ipfiremake libsafe
473 ipfiremake 3c5x9setup
474 ipfiremake pakfire
475 ipfiremake java
476 ipfiremake bootsplash
477 ipfiremake spandsp
478 ipfiremake lzo
479 ipfiremake openvpn
480 ipfiremake pammysql
481 ipfiremake xinetd
482 ipfiremake ghostscript
483 ipfiremake cups
484 ipfiremake samba
485 ipfiremake sudo
486 ipfiremake mc
487 ipfiremake wget
488 ipfiremake wput
489 ipfiremake bridge-utils
490 ipfiremake screen
491 ipfiremake hddtemp
492 ipfiremake smartmontools
493 ipfiremake htop
494 ipfiremake lynx
495 ipfiremake postfix
496 ipfiremake procmail
497 ipfiremake fetchmail
498 ipfiremake cyrusimap
499 ipfiremake webcyradm
500 ipfiremake mailx
501 ipfiremake clamav
502 ipfiremake razor
503 ipfiremake spamassassin
504 ipfiremake amavisd
505 ipfiremake stund
506 ipfiremake libpri
507 # ipfiremake bristuff
508 ipfiremake asterisk
509 ipfiremake mpg123
510 ipfiremake libmad
511 ipfiremake libogg
512 ipfiremake libvorbis
513 ipfiremake lame
514 ipfiremake xvid
515 ipfiremake mpeg2dec
516 ipfiremake ffmpeg
517 ipfiremake sox
518 ipfiremake gnump3d
519 ipfiremake videolan
520 ipfiremake applejuice
521 ipfiremake ocaml
522 ipfiremake mldonkey
523 ipfiremake ntop
524 ipfiremake rsync
525 ipfiremake tcpwrapper
526 ipfiremake portmap
527 ipfiremake nfs
528 ipfiremake nmap
529 ipfiremake mbmon
530 ipfiremake iftop
531 ipfiremake ncftp
532 ipfiremake cftp
533 ipfiremake etherwake
534 ipfiremake ethereal
535 ipfiremake tftp-hpa
536 ipfiremake iptraf
537 ipfiremake bwm-ng
538 ipfiremake nagios
539 ipfiremake tripwire
540 ipfiremake sysstat
541 }
542
543 buildinstaller() {
544 # Run installer scripts one by one
545 LOGFILE="$BASEDIR/log/_build.installer.log"
546 export LOGFILE
547 ipfiremake syslinux
548 ipfiremake as86
549 ipfiremake mbr
550 ipfiremake memtest
551 installmake linux-libc-header
552 installmake binutils
553 ipfiremake uClibc PASS=1
554 ipfiremake gcc INST=1
555 installmake uClibc PASS=2
556 installmake gcc INST=2
557 installmake uClibc PASS=3
558 installmake busybox
559 installmake udev
560 installmake slang
561 installmake newt
562 installmake gettext
563 installmake kbd
564 installmake popt
565 installmake sysvinit
566 installmake misc-progs
567 installmake e2fsprogs
568 installmake libaal
569 installmake reiser4progs
570 installmake reiserfsprogs
571 installmake sysfsutils
572 installmake util-linux
573 installmake pciutils
574 installmake zlib
575 installmake wget
576 installmake libxml2
577 installmake dbus
578 installmake hal
579 installmake hwdata
580 installmake hwinfo
581 installmake kudzu
582 installmake installer
583 installmake initrd
584 }
585
586 buildpackages() {
587 LOGFILE="$BASEDIR/log/_build.packages.log"
588 export LOGFILE
589 echo "... see detailed log in _build.*.log files" >> $LOGFILE
590
591 installmake strip
592
593 # Generating list of packages used
594 echo -n "Generating packages list from logs" | tee -a $LOGFILE
595 rm -f $BASEDIR/doc/packages-list
596 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
597 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
598 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
599 fi
600 done
601 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
602 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
603 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
604 rm -f $BASEDIR/doc/packages-list
605 # packages-list.txt is ready to be displayed for wiki page
606 beautify message DONE
607
608 # Create images for install
609 if [ "$DEVEL" == "1" ]; then
610 ipfiremake cdrom ED=devel
611 fi
612 ipfiremake cdrom ED=full
613
614 # Check if there is a loop device for building in virtual environments
615 if [ -e /dev/loop0 ]; then
616 ipfiremake usb-stick
617 fi
618 ipfiremake pxe
619 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
620
621 # ipfirepackages
622
623 # Cleanup
624 stdumount
625 rm -rf $BASEDIR/build/tmp/*
626
627 # Generating total list of files
628 echo "Generating files list from logs" | tee -a $LOGFILE
629 rm -f $BASEDIR/log/FILES
630 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
631 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
632 echo "##" >>$BASEDIR/log/FILES
633 echo "## `basename $i`" >>$BASEDIR/log/FILES
634 echo "##" >>$BASEDIR/log/FILES
635 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
636 fi
637 done
638 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
639 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
640
641 cd $PWD
642 }
643
644 ipfirepackages() {
645 if [ -d "$BASEDIR/packages" ]; then
646 for i in `ls $BASEDIR/packages`; do
647 touch $BASEDIR/build/install/packages/$i.empty
648 done
649 fi
650 # ipfiredist amavisd
651 ipfiredist applejuice
652 ipfiredist asterisk
653 ipfiredist clamav
654 ipfiredist cups
655 ipfiredist cyrusimap
656 ipfiredist fetchmail
657 ipfiredist ffmpeg
658 ipfiredist gnump3d
659 ipfiredist iptraf
660 ipfiredist java
661 ipfiredist lame
662 ipfiredist libmad
663 ipfiredist libogg
664 ipfiredist libvorbis
665 ipfiredist mailx
666 ipfiredist mldonkey
667 ipfiredist mpeg2dec
668 ipfiredist nagios
669 ipfiredist nfs
670 ipfiredist nmap
671 ipfiredist ntop
672 ipfiredist portmap
673 ipfiredist postfix
674 ipfiredist procmail
675 ipfiredist samba
676 ipfiredist sox
677 ipfiredist spamassassin
678 ipfiredist subversion
679 ipfiredist videolan
680 ipfiredist webcyradm
681 ipfiredist xvid
682 ipfiredist yasuc
683 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
684 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
685 rm -rf $BASEDIR/build/install/packages/*
686 }
687
688 # See what we're supposed to do
689 case "$1" in
690 build)
691 clear
692 BUILDMACHINE=`uname -m`
693 DEVEL=0
694 if [ "$2" == "--devel" ]; then
695 DEVEL=1
696 fi
697 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
698 #only restore on a clean disk
699 if [ ! -f log/cleanup-toolchain-2-tools ]; then
700 if [ ! -n "$PACKAGE" ]; then
701 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
702 prepareenv
703 buildtoolchain
704 else
705 PACKAGENAME=${PACKAGE%.tar.gz}
706 beautify build_stage "Packaged toolchain compilation"
707 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
708 tar zxf $PACKAGE
709 prepareenv
710 else
711 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
712 fi
713 fi
714 else
715 echo -n "Using installed toolchain" | tee -a $LOGFILE
716 beautify message SKIP
717 prepareenv
718 fi
719
720 beautify build_start
721 beautify build_stage "Building LFS"
722 buildbase
723
724 beautify build_stage "Building IPFire"
725 buildipfire
726
727 # Setzen des IPFire Builds
728 if [ "$FIREBUILD" ]; then
729 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
730 else
731 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
732 fi
733
734 beautify build_stage "Building installer"
735 buildinstaller
736
737 beautify build_stage "Building packages"
738 buildpackages
739 beautify build_end
740 ;;
741 shell)
742 # enter a shell inside LFS chroot
743 # may be used to changed kernel settings
744 prepareenv
745 entershell
746 ;;
747 changelog)
748 echo -n "Loading new Changelog from SVN: "
749 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
750 beautify message DONE
751 ;;
752 clean)
753 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
754 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
755 $LOSETUP -d $i 2>/dev/null
756 done
757 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
758 umount $i
759 done
760 stdumount
761 for i in `seq 0 7`; do
762 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
763 umount /dev/loop${i} 2>/dev/null;
764 losetup -d /dev/loop${i} 2>/dev/null;
765 fi;
766 done
767 rm -rf $BASEDIR/build
768 rm -rf $BASEDIR/cdrom
769 rm -rf $BASEDIR/packages
770 rm -rf $BASEDIR/log
771 if [ -h /tools ]; then
772 rm -f /tools
773 fi
774 beautify message DONE
775 ;;
776 downloadsrc)
777 if [ ! -d $BASEDIR/cache ]; then
778 mkdir $BASEDIR/cache
779 fi
780 mkdir -p $BASEDIR/log
781 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
782 FINISHED=0
783 cd $BASEDIR/lfs
784 for c in `seq $MAX_RETRIES`; do
785 if (( FINISHED==1 )); then
786 break
787 fi
788 FINISHED=1
789 cd $BASEDIR/lfs
790 for i in *; do
791 if [ -f "$i" -a "$i" != "Config" ]; then
792 echo -ne "Loading $i"
793 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
794 if [ $? -ne 0 ]; then
795 beautify message FAIL
796 FINISHED=0
797 else
798 if [ $c -eq 1 ]; then
799 beautify message DONE
800 fi
801 fi
802 fi
803 done
804 done
805 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
806 ERROR=0
807 for i in *; do
808 if [ -f "$i" -a "$i" != "Config" ]; then
809 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
810 if [ $? -ne 0 ]; then
811 echo -ne "MD5 difference in lfs/$i"
812 beautify message FAIL
813 ERROR=1
814 fi
815 fi
816 done
817 if [ $ERROR -eq 0 ]; then
818 echo -ne "${BOLD}all files md5sum match${NORMAL}"
819 beautify message DONE
820 else
821 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
822 beautify message FAIL
823 fi
824 cd - >/dev/null 2>&1
825 ;;
826 toolchain)
827 clear
828 prepareenv
829 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
830 buildtoolchain
831 BUILDMACHINE=`uname -m`
832 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
833 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
834 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
835 build/{bin,etc,usr/bin,usr/local} \
836 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
837 log >> $LOGFILE
838 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
839 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
840 stdumount
841 ;;
842 gettoolchain)
843 BUILDMACHINE=`uname -m`
844 # arbitrary name to be updated in case of new toolchain package upload
845 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
846 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
847 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
848 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
849 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
850 cd $BASEDIR/cache/toolchains
851 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
852 if [ $? -ne 0 ]; then
853 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
854 else
855 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
856 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
857 else
858 exiterror "$PACKAGE.md5 did not match, check downloaded package"
859 fi
860 fi
861 else
862 echo "Toolchain is already downloaded. Exiting..."
863 fi
864 ;;
865 othersrc)
866 prepareenv
867 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
868 chroot $LFS /tools/bin/env -i HOME=/root \
869 TERM=$TERM PS1='\u:\w\$ ' \
870 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
871 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
872 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
873 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
874 if [ $? -eq "0" ]; then
875 beautify message DONE
876 else
877 beautify message FAIL
878 fi
879 stdumount
880 ;;
881 svn)
882 case "$2" in
883 update|up)
884 # clear
885 echo -ne "Loading the latest source files...\n"
886 if [ $3 ]; then
887 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
888 else
889 svn update | tee -a $PWD/log/_build.svn.update.log
890 fi
891 if [ $? -eq "0" ]; then
892 beautify message DONE
893 else
894 beautify message FAIL
895 exit 1
896 fi
897 echo -ne "Writing the svn-info to a file"
898 svn info > $PWD/svn_status
899 if [ $? -eq "0" ]; then
900 beautify message DONE
901 else
902 beautify message FAIL
903 exit 1
904 fi
905 chmod 755 $0
906 exit 0
907 ;;
908 commit|ci)
909 clear
910 if [ -f /usr/bin/mcedit ]; then
911 export EDITOR=/usr/bin/mcedit
912 fi
913 if [ -f /usr/bin/nano ]; then
914 export EDITOR=/usr/bin/nano
915 fi
916 echo -ne "Selecting editor $EDITOR..."
917 beautify message DONE
918 if [ -e /sbin/yast ]; then
919 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
920 $0 changelog
921 fi
922 fi
923 update_langs
924 svn commit
925 $0 svn up
926 if [ -n "$FTP_CACHE_URL" ]; then
927 $0 uploadsrc
928 fi
929 ;;
930 dist)
931 if [ $3 ]; then
932 SVN_REVISION=$3
933 fi
934 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
935 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
936 exit 0
937 fi
938 echo -en "REV $SVN_REVISION: Downloading..."
939 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
940 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
941 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
942 evaluate 1
943
944 echo -en "REV $SVN_REVISION: Compressing files..."
945 if [ -e ipfire-source/trunk/make.sh ]; then
946 chmod 755 ipfire-source/trunk/make.sh
947 fi
948 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
949 evaluate 1
950 echo -en "REV $SVN_REVISION: Cleaning up..."
951 rm ipfire-source/ -r
952 evaluate 1
953 ;;
954 diff|di)
955 update_langs
956 echo -ne "Make a local diff to last svn revision"
957 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
958 evaluate 1
959 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
960 svn status
961 ;;
962 esac
963 ;;
964 uploadsrc)
965 PWD=`pwd`
966 cd $BASEDIR/cache/
967 echo -e "Uploading cache to ftp server:"
968 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
969 for i in *; do
970 if [ "$i" == "toolchains" ]; then continue; fi
971 grep -q $i /tmp/ftplist
972 if [ "$?" -ne "0" ]; then
973 echo -ne "$i"
974 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
975 if [ "$?" -ne "0" ]; then
976 beautify message FAIL
977 fi
978 fi
979 done
980 rm -f /tmp/ftplist
981 cd $PWD
982 exit 0
983 ;;
984 upload)
985 case "$2" in
986 iso)
987 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
988 cat <<EOF > .ftp-commands
989 mkdir -p $FTP_ISO_PATH/$SVN_REVISION
990 ls -lah
991 quit
992 EOF
993 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
994 rm -f .ftp-commands
995 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
996 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
997 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
998 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
999 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
1000 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
1001 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
1002 fi
1003 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
1004 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
1005 if [ "$?" -eq "0" ]; then
1006 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1007 else
1008 echo -e "There was an error while uploading the iso to the ftp server."
1009 exit 1
1010 fi
1011 if [ "$3" = "--with-sources-cd" ]; then
1012 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1013 fi
1014 ;;
1015 paks)
1016 cat <<EOF > .ftp-commands
1017 mkdir $IPFIRE_FTP_PATH_PAK
1018 ls -lah
1019 quit
1020 EOF
1021 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
1022 rm -f .ftp-commands
1023 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
1024 if [ "$?" -eq "0" ]; then
1025 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
1026 else
1027 echo -e "There was an error while uploading the packages to the ftp server."
1028 exit 1
1029 fi
1030 ;;
1031 esac
1032 ;;
1033 batch)
1034 if [ "$2" = "--background" ]; then
1035 batch_script
1036 exit $?
1037 fi
1038 if [ `screen -ls | grep -q ipfire` ]; then
1039 echo "Build is already running, sorry!"
1040 exit 1
1041 else
1042 if [ "$2" = "--rebuild" ]; then
1043 export IPFIRE_REBUILD=1
1044 echo "REBUILD!"
1045 else
1046 export IPFIRE_REBUILD=0
1047 fi
1048 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1049 screen -dmS ipfire $0 batch --background
1050 evaluate 1
1051 exit 0
1052 fi
1053 ;;
1054 watch)
1055 watch_screen
1056 ;;
1057 pxe)
1058 case "$2" in
1059 start)
1060 start_tftpd
1061 ;;
1062 stop)
1063 stop_tftpd
1064 ;;
1065 reload|restart)
1066 reload_tftpd
1067 ;;
1068 esac
1069 exit 0
1070 ;;
1071 lang)
1072 update_langs
1073 ;;
1074 "")
1075 clear
1076 svn info
1077 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1078 do
1079 case $name in
1080 "IPFIRE: Downloadsrc")
1081 $0 downloadsrc
1082 ;;
1083 "IPFIRE: Build (silent)")
1084 $0 build-silent
1085 ;;
1086 "IPFIRE: Watch Build")
1087 $0 watch
1088 ;;
1089 "IPFIRE: Batch")
1090 $0 batch
1091 ;;
1092 "IPFIRE: Clean")
1093 $0 clean
1094 ;;
1095 "SVN: Update")
1096 $0 svn update
1097 ;;
1098 "Help")
1099 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1100 cat doc/make.sh-usage
1101 ;;
1102 "LOG: Tail")
1103 tail -f log/_*
1104 ;;
1105 "Exit")
1106 break
1107 ;;
1108 esac
1109 done
1110 ;;
1111 config)
1112 make_config
1113 ;;
1114 *)
1115 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1116 cat doc/make.sh-usage
1117 ;;
1118 esac